﻿package {
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.GradientType;
	import flash.geom.Point;
	import flash.events.*;
	import flash.utils.Timer;
	import flash.text.*;
	import flash.filters.*;
	
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageDisplayState;
	
	import Hexagonfield;
	
	public class Hexagon extends Sprite {
		
		private var hexField:Hexagonfield;
		private var nameString:String;
		
		public var xPos:Number;
		public var yPos:Number;
		
		public var radius:Number;
		
		private var mouseover:Boolean;
		
		private var colorScheme:Boolean = false;
		
		private var values:Array = [];
		private var frame:Number = 0;
		
		public function Hexagon(_hexField:Hexagonfield, _values:Array, _colorSch:Boolean){
			
			hexField = _hexField;
			values = _values;
			
			colorScheme = _colorSch;
			
			xPos = 420;
			yPos = 50;
			radius = 20;
	 
	 		refreshGraphics();
	 
	 		addEventListener(MouseEvent.MOUSE_OVER,function():void{
				//if(graph.draggingNode) return;
				mouseover = true;
				refreshGraphics();
				hexField.feedBack(nameString, values);
	 		});
			
			addEventListener(MouseEvent.MOUSE_OUT,function():void{
				//if(graph.draggingNode) return;
				mouseover = false;
				var tempdata:Array = new Array();
				hexField.feedBack("", tempdata);
				refreshGraphics();
	 		});
			
			addEventListener(MouseEvent.MOUSE_DOWN,function(ev:MouseEvent):void{});

			addEventListener(MouseEvent.MOUSE_UP,function(ev:MouseEvent):void{});
		}
		
		public function refreshGraphics(){
			graphics.clear();
			drawPolygon();
			graphics.endFill();
		}
		
		public function setFrame(_frame:Number){
			frame = _frame;
			refreshGraphics();
		}
		
		public function drawPolygon(){
			
			var points:Array = [];
			
			var i:Number;
			for (i = 0; i < 6; i++) {
				var p:Point = new Point((xPos + radius/2*Math.cos(i*2*Math.PI/6)), (yPos + radius/2*Math.sin(i*2*Math.PI/6)));
				points[i] = p;
			}
			
			if(mouseover){
				graphics.beginFill(0xffcc00);
			}
			else{
				var colorbase:Number = values[frame];
				var red = Math.max(0, 255*colorbase);
				var green = Math.max(0, 255*(-colorbase));
				
				graphics.beginFill(red<<16 | green<<8 | 0);
				
				if(colorScheme){
					var r = Math.max(Math.round(70*Math.abs(colorbase)), Math.round(255*(colorbase)));
					var g = Math.max(Math.round(70*Math.abs(colorbase)), Math.round(255*(colorbase)));
					var b = Math.max(Math.round(70*Math.abs(colorbase)), Math.round(255*(-colorbase)));
					
					graphics.beginFill(r<<16 | g<<8 | b);
				}
				
				
			}

			graphics.moveTo(points[0].x, points[0].y);
			graphics.lineTo(points[1].x, points[1].y);
			graphics.lineTo(points[2].x, points[2].y);
			graphics.lineTo(points[3].x, points[3].y);
			graphics.lineTo(points[4].x, points[4].y);
			graphics.lineTo(points[5].x, points[5].y);
			graphics.lineTo(points[0].x, points[0].y);
			
			graphics.endFill();
			
			graphics.lineStyle(3,0x000000);
			graphics.moveTo(points[0].x, points[0].y);
			graphics.lineTo(points[1].x, points[1].y);
			graphics.lineTo(points[2].x, points[2].y);
			graphics.lineTo(points[3].x, points[3].y);
			graphics.lineTo(points[4].x, points[4].y);
			graphics.lineTo(points[5].x, points[5].y);
			graphics.lineTo(points[0].x, points[0].y);
		}
		
		public function setText(_name:String){
			nameString = _name;
		}
		
		public function setRadius(_radius:Number){
			radius = _radius;
		}
		
		public function setPos(_x:Number, _y:Number){
			xPos = _x;
			yPos = _y;
		}
	}
}
	